
/*! \file
 *
 * \brief PacketCable COPS
 * 
 * \author Attila Domjan <attila.domjan.hu@gmail.com>
 *
 */

enum {
	GATE_SET,
	GATE_INFO,
	GATE_SET_HAVE_GATEID,
	GATE_DEL
};

enum {
	GATE_ALLOC_FAILED,
	GATE_ALLOC_PROGRESS,
	GATE_ALLOCATED,
	GATE_CLOSED,
	GATE_CLOSED_ERR,
	GATE_OPEN,
	GATE_DELETED,
	GATE_TIMEOUT
};

struct cops_gate
{
	AST_LIST_ENTRY(cops_gate) list;
	uint32_t gateid;
	uint16_t trid;
	time_t in_transaction;
	uint32_t mta;
	int state;
	time_t allocated;
	time_t checked;
	time_t deltimer;
	struct cops_cmts *cmts;
	int (* got_dq_gi) (struct cops_gate *gate);
	int (* gate_remove) (struct cops_gate *gate);
	int (* gate_open) (struct cops_gate *gate);
	void *tech_pvt;
};


struct cops_gate * pktccops_gate_alloc(int cmd,  struct cops_gate *gate, uint32_t mta, uint32_t actcount, float bitrate, uint32_t psize, uint32_t ssip, uint16_t ssport, int (* const got_dq_gi) (struct cops_gate *gate), int (* const gate_remove) (struct cops_gate *gate));
